// Klasse, die Mehrfach-Antworten-Fragen realisiert
class MAFrage extends Frage {

	String[] antworten; // moegliche Antworten
	int[] richtigIndizes; // Indizes der richtigen Antworten

	public MAFrage(String text, int punkte, String[] antworten,
			int[] richtigIndizes) {
		super(text, punkte);
		this.antworten = antworten;
		this.richtigIndizes = richtigIndizes;
	}

	// Frage auf den Bildschirm ausgeben
	@Override
	public void frageStellen() {
		super.frageStellen();
		for (int f = 0; f < this.antworten.length; f++) {
			IO.println("(" + f + "): " + this.antworten[f]);
		}
	} // Frage an Pruefling stellen, auswerten und Punkte vergeben

	@Override
	public void frageBeantworten(Pruefling person) {
		int anzahl = IO.readInt("Anzahl der ausgewaehlten Antworten: ");
		int[] indizes = new int[anzahl];
		for (int i = 0; i < anzahl; i++) {
			indizes[i] = IO.readInt("Auswahl (Index): ");
		}

		if (this.korrekteAuswahl(indizes, this.richtigIndizes)) {
			IO.println("Richtige Antwort: " + this.punkte + " Punkte");
			person.neuePunkte(this.punkte);
		} else {
			IO.println("Falsche Antwort: 0 Punkte!");
			IO.print("Richtige Antworten sind: ");
			for (int i = 0; i < this.richtigIndizes.length - 1; i++) {
				IO.print(this.richtigIndizes[i] + ", ");
			}
			IO.println(this.richtigIndizes[this.richtigIndizes.length - 1]);
		}
	}

	private boolean korrekteAuswahl(int[] indizes, int[] korrekteIndizes) {
		// zunaechst ueberpruefen, ob alle gegebenen Antworten ok sind
		for (int i = 0; i < indizes.length; i++) {
			boolean enthalten = false;
			for (int k = 0; k < korrekteIndizes.length; k++) {
				if (indizes[i] == korrekteIndizes[k]) {
					enthalten = true;
					break;
				}
			}
			if (!enthalten) {
				return false;
			}
		}

		// nun ueberpruefen, ob alle korrekten Antworten auch ausgewaehlt wurden
		for (int k = 0; k < korrekteIndizes.length; k++) {
			boolean enthalten = false;
			for (int i = 0; i < indizes.length; i++) {
				if (indizes[i] == korrekteIndizes[k]) {
					enthalten = true;
					break;
				}
			}
			if (!enthalten) {
				return false;
			}
		}

		return true;
	}
}

public class UE19Aufgabe1 {

	// Hauptprogramm
	public static void main(String[] args) {
		Pruefung klausur = new Pruefung();
		klausur.vorbereiten();
		klausur.durchfuehren();
		klausur.ergebnisseBekanntgeben();
	}

	Quiz pruefung;

	Pruefling[] studenten;

	UE19Aufgabe1() {
		this.pruefung = null;
		this.studenten = null;
	}

	void vorbereiten() {
		IO.println("Fragen eingeben");
		IO.println("----------------");
		String titel = IO.readString("Titel des Quizes: ");
		int anzahl = IO.readInt("Anzahl Fragen: ");
		this.pruefung = new Quiz(titel, anzahl);
		// Fragen eingeben
		for (int i = 0; i < anzahl; i++) {
			Frage f = this.frageErzeugen(i + 1);
			this.pruefung.neueFrage(f);
		}
	}

	public Frage frageErzeugen(int nummer) {
		// spaeter Factory-Pattern
		int typ = IO
				.readInt("Fragetyp: Wahr/Falsch (1), Multiple Choice (2), Mehrfachauswahl (3)?");
		switch (typ) {
		case 1:
			return this.erzeugeWahrFalschFrage(nummer);
		case 2:
			return this.erzeugeMCFrage(nummer);
		case 3:
		default:
			return this.erzeugeMAFrage(nummer);
		}
	}

	private Frage erzeugeWahrFalschFrage(int nummer) {
		String text = IO.readString("Frage " + nummer + ": ");
		boolean wahr = IO.readChar("Wahr/falsch(w/f)?") == 'w';
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new WahrFalschFrage(text, punkte, wahr);
	}

	private Frage erzeugeMCFrage(int nummer) {
		String text = IO.readString("Frage " + nummer + ": ");
		int anzahl = IO.readInt("Anzahl an Antworten: ");
		String[] antworten = new String[anzahl];
		for (int i = 0; i < anzahl; i++) {
			antworten[i] = IO.readString("Antwort " + i + ": ");
		}
		int richtigIndex = IO.readInt("Index der richtigen Antwort: ");
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new MCFrage(text, punkte, antworten, richtigIndex);
	}

	private Frage erzeugeMAFrage(int nummer) {
		String text = IO.readString("Frage " + nummer + ": ");
		int anzahl = IO.readInt("Anzahl an Antworten: ");
		String[] antworten = new String[anzahl];
		for (int i = 0; i < anzahl; i++) {
			antworten[i] = IO.readString("Antwort " + i + ": ");
		}
		int anzahlIndizes = IO.readInt("Anzahl an korrekten Indizes: ");
		int[] indizes = new int[anzahlIndizes];
		for (int i = 0; i < anzahlIndizes; i++) {
			indizes[i] = IO.readInt("Index: ");
		}
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new MAFrage(text, punkte, antworten, indizes);
	}

	void durchfuehren() {
		IO.println("Pruefung");
		IO.println("--------");
		int anzahl = IO.readInt("Anzahl Prueflinge: ");
		this.studenten = new Pruefling[anzahl];
		// alle Prueflinge abfragen
		for (int i = 0; i < anzahl; i++) {
			IO.println("Pruefling " + (i + 1) + " ist an der Reihe");
			this.studenten[i] = new Pruefling(IO.readString("Name: "));
			Frage f = null;
			// alle Fragen der Pruefung stellen
			while ((f = this.pruefung.liefereNaechsteFrage()) != null) {
				f.frageStellen();
				f.frageBeantworten(this.studenten[i]);
			}
		}
	}

	void ergebnisseBekanntgeben() {
		this.ranglisteErstellen();
		IO.println("Pruefungsergebnisse");
		IO.println("-------------------");
		IO.println("Quiz: " + this.pruefung.getTitel());
		for (int i = 0; i < this.studenten.length; i++) {
			IO.println("Platz " + (i + 1) + ": " + this.studenten[i].getName()
					+ " mit " + this.studenten[i].getPunkte() + " Punkten");
		}
	}

	private void ranglisteErstellen() {
		// Bubblesort nach erreichten Punkten
		boolean veraendert = false;
		do {
			veraendert = false;
			for (int i = 0; i < this.studenten.length - 1; i++) {
				if (this.studenten[i].getPunkte() < this.studenten[i + 1]
						.getPunkte()) {
					Pruefling help = this.studenten[i];
					this.studenten[i] = this.studenten[i + 1];
					this.studenten[i + 1] = help;
					veraendert = true;
				}
			}
		} while (veraendert);
	}
}
