abstract class BildFilter {

	protected BildFilter vorFilter;

	public BildFilter() {
		this.vorFilter = null;
	}

	public BildFilter(BildFilter vorherige) {
		this.vorFilter = vorherige;
	}

	public byte[] transformieren(byte[] bytes) {
		if (this.vorFilter != null) {
			bytes = this.vorFilter.transformieren(bytes);
		}
		return bytes;
	}
}

class GaussFilter extends BildFilter {

	public GaussFilter() {
		super();
	}

	public GaussFilter(BildFilter vorheriger) {
		super(vorheriger);
	}

	@Override
	public byte[] transformieren(byte[] bytes) {
		bytes = super.transformieren(bytes);
		for (int i = 0; i < bytes.length; i++) {
			bytes[i] = (byte) (bytes[i] + 1);
		}
		return bytes;
	}
}

class LaplaceFilter extends BildFilter {

	public LaplaceFilter() {
		super();
	}

	public LaplaceFilter(BildFilter vorheriger) {
		super(vorheriger);
	}

	@Override
	public byte[] transformieren(byte[] bytes) {
		bytes = super.transformieren(bytes);
		for (int i = 0; i < bytes.length; i++) {
			bytes[i] = (byte) (bytes[i] - 1);
		}
		return bytes;
	}
}

class MedianFilter extends BildFilter {

	public MedianFilter() {
		super();
	}

	public MedianFilter(BildFilter vorheriger) {
		super(vorheriger);
	}

	@Override
	public byte[] transformieren(byte[] bytes) {
		bytes = super.transformieren(bytes);
		for (int i = 0; i < bytes.length; i++) {
			bytes[i] = (byte) (bytes[i] + 2);
		}
		return bytes;
	}
}

class BinomialFilter extends BildFilter {

	public BinomialFilter() {
		super();
	}

	public BinomialFilter(BildFilter vorheriger) {
		super(vorheriger);
	}

	@Override
	public byte[] transformieren(byte[] bytes) {
		bytes = super.transformieren(bytes);
		for (int i = 0; i < bytes.length; i++) {
			bytes[i] = (byte) (bytes[i] + 3);
		}
		return bytes;
	}
}

public class UE19Aufgabe7 {

	public static void main(String[] args) {
		BildFilter pipeline = new GaussFilter(new LaplaceFilter(new MedianFilter()));
		// BildFilter pipeline = new LaplaceFilter(new GaussFilter(
		// new BinomialFilter()));
		while (true) {
			byte[] pictureData = readFile("holiday.gif");
			show(pipeline.transformieren(pictureData));
		}
	}

	static byte[] readFile(String dateiname) {
		return null;
	}

	static void show(byte[] picture) {
	}

}
